import { PropType, Ref } from "vue";
import { LocationQueryValue, RouteLocationNormalizedLoaded, Router } from "vue-router";
export declare type TabEntry = {
    id: string;
    scrollDestId?: string;
};
export declare type AppendTabFunction = (entry: TabEntry) => void;
export declare type RemoveTabFunction = (entry: TabEntry) => void;
export declare type SelectTabEventHandler = (event: {
    id: string;
    scrollDestId?: string;
}) => void;
export declare type TabHandler = {
    currentTabId: Ref<string | undefined>;
    appendTab: AppendTabFunction;
    removeTab: RemoveTabFunction;
    selectTab: SelectTabEventHandler;
};
export declare type ScrollToTabOption = {
    offset: number;
};
export declare const useTabHandler: () => TabHandler | undefined;
declare const _sfc_main: import("vue").DefineComponent<{
    modelValue: {
        type: StringConstructor;
        default: undefined;
    };
    useSwiper: {
        type: BooleanConstructor;
        default: boolean;
    };
    useScrollToTab: {
        type: PropType<boolean | ScrollToTabOption>;
        default: undefined;
    };
}, {
    swiper: Ref<({
        $: import("vue").ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            loop: boolean;
            direction: "vertical" | "horizontal";
            autoHeight: boolean;
            fade: boolean;
            slidesPerView: number | "auto";
            centeredSlides: boolean;
            scrollbar: boolean;
        }> & Omit<Readonly<import("vue").ExtractPropTypes<{
            index: NumberConstructor;
            slidesPerView: {
                type: PropType<number | "auto">;
                default: number;
            };
            spaceBetween: NumberConstructor;
            scrollbar: BooleanConstructor;
            pagination: PropType<boolean | import("swiper/types").PaginationOptions>;
            navigation: PropType<boolean | import("swiper/types").NavigationOptions>;
            loop: BooleanConstructor;
            autoHeight: BooleanConstructor;
            freeMode: PropType<boolean | import("swiper/types").FreeModeOptions>;
            breakpoints: PropType<{
                sm?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
                md?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
                lg?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
                xl?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
            }>;
            direction: {
                type: PropType<"vertical" | "horizontal">;
                default: string;
            };
            fade: BooleanConstructor;
            autoplay: PropType<boolean | import("swiper/types").AutoplayOptions>;
            centeredSlides: BooleanConstructor;
            slidesPerGroup: NumberConstructor;
        }>> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, "loop" | "direction" | "autoHeight" | "fade" | "slidesPerView" | "centeredSlides" | "scrollbar">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: import("vue").Slot | undefined;
        }>;
        $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
        $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
        $emit: (event: string, ...args: any[]) => void;
        $el: any;
        $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
            index: NumberConstructor;
            slidesPerView: {
                type: PropType<number | "auto">;
                default: number;
            };
            spaceBetween: NumberConstructor;
            scrollbar: BooleanConstructor;
            pagination: PropType<boolean | import("swiper/types").PaginationOptions>;
            navigation: PropType<boolean | import("swiper/types").NavigationOptions>;
            loop: BooleanConstructor;
            autoHeight: BooleanConstructor;
            freeMode: PropType<boolean | import("swiper/types").FreeModeOptions>;
            breakpoints: PropType<{
                sm?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
                md?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
                lg?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
                xl?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
            }>;
            direction: {
                type: PropType<"vertical" | "horizontal">;
                default: string;
            };
            fade: BooleanConstructor;
            autoplay: PropType<boolean | import("swiper/types").AutoplayOptions>;
            centeredSlides: BooleanConstructor;
            slidesPerGroup: NumberConstructor;
        }>>, {
            modules: import("swiper/types").SwiperModule[];
            swiperRef: Ref<any>;
            swiper: import("vue").ComputedRef<any>;
            onSlideChange: () => void;
            currentIndex: Ref<any>;
            autoplaying: Ref<any>;
            setAutoPlaying: (value: boolean) => void;
            breakpointOptions: import('../components/UiSwiper.vue').BreakpointsOptions | undefined;
        }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
            loop: boolean;
            direction: "vertical" | "horizontal";
            autoHeight: boolean;
            fade: boolean;
            slidesPerView: number | "auto";
            centeredSlides: boolean;
            scrollbar: boolean;
        }, {}, string> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof import("vue").nextTick;
        $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean> | undefined): import("vue").WatchStopHandle;
    } & Readonly<import("vue").ExtractPropTypes<{
        index: NumberConstructor;
        slidesPerView: {
            type: PropType<number | "auto">;
            default: number;
        };
        spaceBetween: NumberConstructor;
        scrollbar: BooleanConstructor;
        pagination: PropType<boolean | import("swiper/types").PaginationOptions>;
        navigation: PropType<boolean | import("swiper/types").NavigationOptions>;
        loop: BooleanConstructor;
        autoHeight: BooleanConstructor;
        freeMode: PropType<boolean | import("swiper/types").FreeModeOptions>;
        breakpoints: PropType<{
            sm?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
            md?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
            lg?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
            xl?: import('../components/UiSwiper.vue').BreakpointOption | undefined;
        }>;
        direction: {
            type: PropType<"vertical" | "horizontal">;
            default: string;
        };
        fade: BooleanConstructor;
        autoplay: PropType<boolean | import("swiper/types").AutoplayOptions>;
        centeredSlides: BooleanConstructor;
        slidesPerGroup: NumberConstructor;
    }>> & import("vue").ShallowUnwrapRef<{
        modules: import("swiper/types").SwiperModule[];
        swiperRef: Ref<any>;
        swiper: import("vue").ComputedRef<any>;
        onSlideChange: () => void;
        currentIndex: Ref<any>;
        autoplaying: Ref<any>;
        setAutoPlaying: (value: boolean) => void;
        breakpointOptions: import('../components/UiSwiper.vue').BreakpointsOptions | undefined;
    }> & {} & import("vue").ComponentCustomProperties & {}) | undefined>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': null;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    modelValue: {
        type: StringConstructor;
        default: undefined;
    };
    useSwiper: {
        type: BooleanConstructor;
        default: boolean;
    };
    useScrollToTab: {
        type: PropType<boolean | ScrollToTabOption>;
        default: undefined;
    };
}>> & {
    "onUpdate:modelValue"?: ((...args: any[]) => any) | undefined;
}, {
    modelValue: string;
    useSwiper: boolean;
    useScrollToTab: boolean | ScrollToTabOption;
}>;
/**
 * `UiTabs` 를 router 에 연결해 사용할 때 필요한
 * `selectedTabId` 변수와 `changeRouterTab` 함수를 리턴한다.
 *
 * ```html
 * <UiTabs v-model="selectedTabId" @update:modelValue="changeRouterTab">
 * ```
 *
 * ```ts
 * setup() {
 *   return {
 *     ...useRouterTab(router, route, 'tab')
 *   }
 * }
 * ```
 * @param router Router 객체. `useRouter()` 로 얻을 수 있다.
 * @param route Route 객체. `useRoute()` 로 얻을 수 있다.
 * @param defaultTabId router query 에 탭이 없을 때 디폴트 값으로 사용되는 tab id.
 * @param paramName router query 에 추가될 파라미터 명
 */
export declare const useRouterTab: (router: Router, route: RouteLocationNormalizedLoaded, defaultTabId: string, paramName?: string) => {
    selectedTabId: Ref<string | LocationQueryValue[] | null>;
    changeRouterTab: (tabId: string, tabs: Ref<TabEntry[]>) => void;
};
export default _sfc_main;
